
/* ***** IMPORTANT  *****                                        */
/* The default directory for BGI files & fonts for               */
/* Turbo C++  is c:\\tc\\bgi   &                                 */
/* Turbo C 2.0 is c:\\tc                                         */
/* If your BGI files & fonts are not found in that directory, be */
/* sure to change the definition of the constant 'defaultfontdir' */
/* in the file rtstdhdr.h prior to running this demo !!          */

/* program rtdemo.c */

	/**************************************
	 ALL FUNCTIONS BEGINNING WITH "rt" ARE
	 PART OF THE RTLib488 TOOLS LIBRARY
	**************************************/

#include <time.h>
#include <dos.h>
#include <conio.h>
#include <string.h>
#include <conio.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include "rtstdhdr.h"
#include "rtgsubs.h"
#include "rtbargr.h"
#include "rtgraph.h"
#include "rtmeter.h"
#include "rttext.h"
#include "rtgcommo.h"
#include "rtmouse.h"
#include "rtchart.h"

rtstatpntr rtstat[22];
int mousefound,mainaction,buttons;
realtype   *xdata,*ydata,*ydata2,*ydata3,*ydata4,*tcxs,*tcfitted,*tcactual,
*lalarm,*halarm,*stpnt,*y3values,*y2values,*yvalues;
realtype rr,xx1,yy1;
int lc[16],lc2[16],lf[16];
realtype logvals[16];
tagtype *tags,*units,*halarms,*lalarms,*nalarms;
messagetype message[16];
alarmstrtype alarmstrings[16];
int farray[16];
unsigned index;
char ch;

realtype  timeint, sampleint, miny, maxy, rt;
int nt, grid, xdecs, ydecs, i1,i2,i3;


realtype getseconds(void) 
{
    time_t ts1;
    realtype result;

    time(&ts1);
    result = (realtype) ts1;
    return(result);
}

void rtclearscreen(void)
{
    if (mousefound)
	rthidemouse();
    rtsetgraphviewport(0,0,getmaxx(), getmaxy());
    clearviewport();
}

int checkevent(void)
{
    int status,x,y, result;

    status = 0;
    if (mousefound)
	rtgetmouse(&status,&x,&y);
    result = 0;
    if (status != 0)
	result = 2;
    if (kbhit())
	result = 1;
    return(result);
}

char getkey(void)
{
    char result,firstkey;

    firstkey = 0;
    if (kbhit())
    {
	firstkey = (char)getch();
    }
    result = firstkey;
    return(result);
}

void xtext(char *s1, char *s2, char *s3)
{
    int lx,ly,lyinc,i,j;
    char s[80];

    rtsdrvp(rtstat[0]);
    ly = rtviewportheight() / 2;
    lx = rtviewportwidth() / 2;
    settextjustify(1,1);
    for (j = 0; j <= 2; j ++)
    {
	switch (j) 
	{
	case 0:
	    strcpy(s ,s1);
	    break;
	case 1:
	    strcpy(s , s2);
	    break;
	case 2:
	    strcpy(s ,s3);
	    break;
	}
	for (i = 1; i <= 2; i++)
	{
	    settextstyle(0,0,i);
	    rtsetcolor(15);
	    moveto(lx,ly);
	    outtext(s);
	    rtdelay(50);
	    if (i != 8)
	    {
		rtsetcolor((*rtstat[0]).pbgcolor);
		moveto(lx,ly);
		outtext(s);
	    }
	}
	moveto(lx+1,ly);
	outtext(s);
	rtdelay(300);
	rtsetcolor((*rtstat[0]).pbgcolor);
	moveto(lx,ly);
	outtext(s);
	moveto(lx+1,ly);
	outtext(s);
    }
}

void drawdiagram(rtstattype *w)
{
    rtsetwindow(w);
    rtsetworldcoordinates(0.0, 0.0, 1.0, 1.0);
    rtbartextworld(0.15,0.6, 0.3,0.15,"1/sTi", 9,0 );
    rtbartextworld( 0.45,0.3, 0.3,0.15,"Kc", 9,0 );
    rtbartextworld( 0.73,0.3, 0.3,0.18 ,"Kp/(1+sT)", 9,0 );

    rtcircletextworld( 0.075,0.45, 0.03 ,"X", 10,0 );
    rtcircletextworld( 0.35,0.45, 0.03 ,"X", 10,0 );
    rtcircletextworld( 0.675,0.45, 0.03 ,"X", 10,0 );

    rtsetcolor(15);

    rtmoveworldabs(0.01,0.45);
    rtlineworldabs(0.055,0.45);

    rtmoveworldabs(0.095,0.45);
    rtlineworldabs(0.33,0.45);

    rtmoveworldabs(0.37,0.45);
    rtlineworldabs(0.45,0.45);

    rtmoveworldabs(0.60,0.45);
    rtlineworldabs(0.655,0.45);

    rtmoveworldabs(0.695,0.45);
    rtlineworldabs(0.73,0.45);

    rtmoveworldabs(0.91,0.45);
    rtlineworldabs(0.99,0.45);

    rtmoveworldabs(0.95,0.45);
    rtlineworldabs(0.95,0.20);
    rtlineworldabs(0.075,0.20);
    rtlineworldabs(0.075,0.42);

    rtmoveworldabs(0.12,0.45);
    rtlineworldabs(0.12,0.75);
    rtlineworldabs(0.15,0.75);

    rtmoveworldabs(0.30,0.75);
    rtlineworldabs(0.35,0.75);
    rtlineworldabs(0.35,0.47);

    rtmoveworldabs(0.675,0.70);
    rtlineworldabs(0.675,0.46);


    rtmoveworldabs(0.04,0.47);
    outtext("+");
    rtmoveworldabs(0.05,0.38);
    outtext("-");

    rtmoveworldabs(0.36,0.47);
    outtext("+");
    rtmoveworldabs(0.32,0.38);
    outtext("+");


    rtmoveworldabs(0.635,0.46);
    outtext("+");
    rtmoveworldabs(0.695,0.46);
    outtext("-");

    rtmoveworldabs(0.01,0.53);
    outtext("R(s)");
    rtmoveworldabs(0.92,0.48);
    outtext("e(s)");
    rtmoveworldabs(0.680,0.70);
    outtext("L(s)");

    rtmoveworldabs(0.20,0.93);
    outtext("Reactor Model as a First Order System");

}

void cwintext(rtstattype *win, int y,int c, char *s)
{
    int xx,yy;

    rtsdrvp(win);
    settextjustify(1,0);
    rtsetcolor(c);
    xx = rtviewportwidth() / 2;
    yy = y * (2+textheight("x"))+2;
    moveto(xx,yy);
    outtext(s);
    settextjustify(0,0);
}

void cboldtitle(rtstattype *win, int y, int c, char *s)
{
    int xx,yy;

    rtsdrvp(win);
    settextjustify(1,0);
    rtsetcolor(c);
    xx = rtviewportwidth() / 2;
    yy = y * (2+textheight("x"))+4;
    moveto(xx,yy);
    outtext(s);
    moveto(xx+1,yy);
    outtext(s);
    settextjustify(0,0);
}

void rtresetwindowdefaults(int num)
{
    int i;

    for (i = 0; i <= num-1; i++)
    {
	rtclearwindowdata(rtstat[i]);
    }
}


void sizescrollwin1(void)
{
    rtsetpercentwindow(rtstat[0],0.01,0.11,0.33,0.60);
    rtsetpercentwindow(rtstat[1],0.34,0.11,0.65,0.60);
    rtsetpercentwindow(rtstat[2],0.66,0.11,0.99,0.60);
    rtsetwin2plotratio(rtstat[2],0.20,0.2,0.03,0.20);
}

void setupscrollwin1(void)
{
    int lfill[4],lcolor[4],i,k ;

    for (i = 0 ; i <= 2; i++)
    {
	if (getmaxcolor() > 1)
	    rtinitwindowcolors(rtstat[i],7,0,1,4,15,15,15);
	else
	    rtinitwindowcolors(rtstat[i],0,0,0,0,0,15,15);

	switch (i) 
	{
	case 0:
	    strcpy(tags[0],"TAG1");
	    strcpy(tags[1],"TAG2");
	    lcolor[0] = 14;
	    lcolor[1] = 11;
	    lfill[0] = 0;
	    lfill[1] = 0;
	    rtsetupsweepgraph(rtstat[i],4.0, 0.1, -5.0, 5.0, 0.95,
	      2, 10, -4.0, 4.0, 0.0, 1, 1,
	      "Sweep Graph", "mV", tags, lc, lf, 0);
	    break;
	case 1:
	    strcpy(tags[0],"TAG3");
	    strcpy(tags[1],"TAG4");
	    strcpy(tags[2],"TAG5");
	    strcpy(tags[3],"TAG6");
	    for (k = 0; k < nt ; k++)
	    {
		lcolor[k] = k+2;
		lfill[k] = 0;
	    }
	    rtsetuplogicgraph(rtstat[i],2.0, 0.05, 0.5, 2, 0,1,
	      "Logic Graph",tags,lc,lf);
	    break;
	case 2:
	    strcpy(tags[0],"TAG7");
	    strcpy(tags[1], "TAG8");
	    strcpy(tags[2], "TAG9");
	    strcpy(tags[3], "TAG10");
	    for (k = 0; k <=  nt-1; k++)
	    {
		lcolor[k] = 14-k;
		lfill[k] = 0;
	    }
	    rtsetupscrollgraph(rtstat[i],2.0, 0.02, 0.0, 500.0, 0.99,
	      1, 0, 75.0, 400.0, 200.0, 1,0,
	      "Scroll Graph", "MilliVolts", tags, lc, lf, 0);
	    break;
	}
	rtborderwindow(rtstat[i],15);
    }

}


void displayscroll1(void)
{
    realtype cursec,startsec;

    index = 0;
    startsec = getseconds();
    do 
    {
	yvalues[0] = 300 + ydata[(int) index];
	yvalues[1] = 100 + ydata[(int) (index+3) % 500];
	yvalues[2] = 200 + ydata[(int) (index+10) % 500];
	yvalues[3] = 300 + ydata[(int) (index+14) % 500];
	logvals[0] = (realtype) abs( (int)(ydata[(int) index % 500]) % 2);
	logvals[1] = (realtype) abs( (int)(ydata[(int) (index+10) % 500]) % 2);
	logvals[2] = (realtype) abs( (int)(ydata[(int) (index+17) % 500]) % 2);
	logvals[3] = (realtype) abs( (int)(ydata[(int) (index+20) % 500]) % 2);
	rtupdatedisplay(rtstat[1],logvals);
	rtupdatedisplay(rtstat[2],yvalues);
	yvalues[0]= ydata2[(int) index];
	yvalues[1]= ydata3[(int) index];
	rtupdatedisplay(rtstat[0],yvalues);
	index = (index+1) % 500;
	;
	cursec = getseconds();
    } while ((checkevent() == 0)  && (cursec < startsec+10))
	;
    if ((checkevent() == 1))
	ch = getkey();
    rtclearwindow(rtstat[3]);

}

void buildscrollp1(void)
{
    int i;
    realtype pinum;

    rtclearscreen();
    rtresetwindowdefaults(20);
    pinum = 2.0  * 3.1415 / 50.0;
    for (i = 0; i <= 510; i++)
    {
	rr = (realtype)i;
	ydata[i] = 50.0 * rtrandom()+ (50.0+i/5.0)  * sin(rr*pinum);
	ydata2[i] = sin(M_PI*rr/52.0) * (rtrandom()) * 1.1;
	rr = rtrandom();
	ydata3[i] = 2 * cos(M_PI*i/(19.0 + rr)) + 2.5 *cos(M_PI*i/64.0 );
	ydata4[i] =  200.0 * (1.0-exp(-rr/100.0))* cos(M_PI * rr);

    }

    rtsetpercentwindow(rtstat[7],0.0,0.0,1.0,0.10);
    rtsetpercentwindow(rtstat[8],0.0,0.61,1.0,1.0);
    rtborderwindow(rtstat[7],15);
    rtborderwindow(rtstat[8],15);
    sizescrollwin1();
    setupscrollwin1();


    settextstyle(1,0,1);
    cboldtitle(rtstat[7],1,15,"Scrolling, Sweep and Logic Graphs");
    settextstyle(1,0,1);
    cwintext(rtstat[8],1,15,"Flexible Graph Window Sizing");
    cwintext(rtstat[8],2,15,"Up to 16 Traces per Graph Window");
    cwintext(rtstat[8],3,15,"High and Low Alarm Markers");
    cwintext(rtstat[8],4,15,"PID Setpoint Marker");
    cwintext(rtstat[8],5,15,"Programmable Reset Interval");
    cwintext(rtstat[8],6,15,"Grids with Programmable Update Intervals");
    cwintext(rtstat[8],7,15,"All Colors are User Programmable");

    settextstyle(0,0,1);
    cwintext(rtstat[8],12,15,"PRESS ANY KEY TO CONTINUE");
    if (mousefound)
	rtshowmouse();
    displayscroll1();

}


void buildap1(void)
{
    char *title ,*units;
    int nc,nr,i;
    realtype *hdata;
    realtype  o2index, o2i, *ahalarm, *alalarm, *astpnt;
    tagtype   *atags, *aunits, *ahalarms, *alalarms, *analarms;
    realtype  cursec,startsec;

    title = (char *) calloc(1,80);
    units = (char *) calloc(1,40);
    hdata =  (realtype *) calloc(50,sizeof(realtype));
    ahalarm= (realtype *) calloc(16,sizeof(realtype));
    alalarm = (realtype *) calloc(16,sizeof(realtype));
    astpnt= (realtype *) calloc(16,sizeof(realtype));
    atags = (tagtype *) calloc(16,sizeof(tagtype));
    aunits = (tagtype *) calloc(16,sizeof(tagtype));
    ahalarms = (tagtype *) calloc(16,sizeof(tagtype));
    alalarms = (tagtype *) calloc(16,sizeof(tagtype));
    analarms = (tagtype *) calloc(16,sizeof(tagtype));

    rtclearscreen();
/*  rtresetwindowdefaults(20); */
    hdata[0] = 0.0;
    hdata[1] = 0.6;
    hdata[2] = 0.75;
    hdata[3] = 0.6;
    hdata[4] = -0.15;
    hdata[5] = -0.20;
    hdata[6] = -0.175;
    hdata[7] = 0.15;
    hdata[8] = 0.2;
    hdata[9] = 0.175;
    hdata[10] = 0.0;
    hdata[11] = 0.0;
    hdata[12] = 0.025;
    hdata[13] = 0.035;
    hdata[14] = 0.025;
    for (i = 15; i <= 49; i++)
	hdata[i] = 0.0;

    for (i = 0; i <= 510; i++)
    {
	ydata[i] = hdata[i % 50];
	ydata2[i] = sin(M_PI*i/52) * (rtrandom()) * 1.1;
	ydata3[i] = rtrandom()-0.5;
    }
    startsec = getseconds();
    strcpy(atags[0], "SYSTOLIC");
    strcpy(atags[1], "DIASTOLIC");
    strcpy(atags[2], "PULSE");
    strcpy(atags[3],"O2");
    for (i = 0; i <= 3; i++)
    {
	if (i <= 3)
	    farray[i] = 1;
	else
	    farray[i] = 0;
	lc[i] = 15;
	strcpy(aunits[i], "");
	strcpy(alalarms[i],"LAlarm");
	strcpy(analarms[i],"OK");
	strcpy(ahalarms[i],"HAlarm");
	alalarm[i] = -300.0;
	ahalarm[i] = 175.0;
	astpnt[i] = 4.0;
    }


    rtsetpercentwindow(rtstat[0],0.01,0.01,0.6,0.6);
    rtsetpercentwindow(rtstat[1],0.01,0.61,0.6,1.0);
    rtsetpercentwindow(rtstat[2],0.61,0.01,0.9,0.3);
    rtsetpercentwindow(rtstat[3],0.61,0.31,0.78,0.76);
    rtsetpercentwindow(rtstat[4],0.61,0.76,0.85,1.0);


    nr = 2;
    nc = 2;
    if (getmaxcolor() == 1)
	rtinitwindowcolors(rtstat[2],0,0,0,0,0,15,15);

    rtsetupannun(rtstat[2], alalarm, ahalarm, astpnt, 1,"Vitals",
      aunits,atags, ahalarms, alalarms,analarms,nr,nc,lc,farray);



    strcpy(tags[0], "TIME IN SECONDS");
    strcpy(units,"Normalized");
    strcpy(title, "EKG");

    nt =1;
    for (i = 0; i <= nt-1; i++)
    {
	lc[i] = 14-i;
	lf[i] = 0;
    }

    for (i = 0; i <= 1; i++)
    {
	if (getmaxcolor() == 1)
	    rtinitwindowcolors(rtstat[i],0,0,9,12,15,15,15);
	rtsetupscrollgraph(rtstat[i],5.0, 0.02, -1.0, 1.0, 0.9,
	  1, 0, -0.8, 0.8, 200.0, 2,1,title, units,
	  tags, lc, lf, 0);
	lc[0] = 12;
	rtborderwindow(rtstat[i],15);
	strcpy(title, "Brain Wave");
    }

    strcpy(alarmstrings[0], "LAlarm");
    strcpy(alarmstrings[1], "");
    strcpy(alarmstrings[2], "HAlarm");
    nt = 1;

    strcpy(tags[0], "");
    lc[0]= 14;
    lf[0] = 0;
    rtinitwindowcolors(rtstat[3],0,0,9,12,15,15,15);

    rtsetupvbargraph(rtstat[3], -1.0, 1.0, 0.0, -0.8, 0.8, 200.0,
      2,"Dias. Pres.",  units, tags, alarmstrings,1,lc, lf);
    lc[0]= 9;
    lf[0] = 0;
    rtinitwindowcolors(rtstat[4],0,0,9,12,15,15,15);
    rtsetuppiemeter(rtstat[4],0.0, 10.0, 0.0, 0.5,
      0.5, 0.4, 1,180, 1.0, 9.0, 5.0,1,
      "","O2 L/min",tags,alarmstrings,
      1,5, 1, lc,lf);
    rtborderwindow(rtstat[4],9);


    index = 0;
    o2index = 1.0;
    o2i = 1.0;
    do 
    {
	yvalues[0] =  ydata[(int) index % 500];
	rtupdatescrollgraph(rtstat[0],yvalues);
	rtupdatevbargraph(rtstat[3], yvalues);

	yvalues[0] =  ydata3[(int) index % 500];
	rtupdatescrollgraph(rtstat[1],yvalues);

	if (index  % 3 == 0)
	{
	    rr = rtrandom();
	    yvalues[0] = 130.0 + rr;
	    rr = rtrandom();
	    yvalues[1] = 85.0 + rr;
	    if (index < 200)
		yvalues[2] = 66.0;
	    else
		yvalues[2] = 67.5;
	    yvalues[3] = 0.82;
	    rtupdateannun(rtstat[2],yvalues);

	}
	if (index % 10 == 0 )
	{
	    yvalues[0] = o2index + rr;
	    o2index = o2index + o2i;
	    if (o2index >= 8.0)
		o2i = -1.0;
	    if (o2index <= 1.0)
		o2i = 1.0;
	    rtupdatepiemeter(rtstat[4], yvalues);
	}
	index++;
	cursec = getseconds();
    } while ((checkevent() == 0)  && (cursec < startsec+15))
	;
    if (checkevent() == 1)
	ch = getkey();
}

void buildtcp1(void)
{
    int numdat,i;
    realtype *yact, *yest, *xact;
    realtype cursec,startsec;
    FILE *tcfile;

    rtclearscreen();
    rtresetwindowdefaults(20);
    rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);
    rtsetpercentwindow(rtstat[1],0.0,0.11,1.0,0.57);
    rtsetpercentwindow(rtstat[2],0.0,0.58,1.0,1.0);

    startsec = getseconds();
    for (i = 0; i <= 2; i++)
	rtborderwindow(rtstat[i],15);
    settextstyle(1,0,1);
    cboldtitle(rtstat[0],1,15,"Thermocouple Curvefitting");
    settextstyle(1,0,1);
    cwintext(rtstat[2],1,15,"Polynomial Curvefitting for All Thermocouple Types");
    cwintext(rtstat[2],2,15,"Temperature to Volts and Volts to Temperature");
    cwintext(rtstat[2],3,15,"Up to 20th Order Polynomials");
    cwintext(rtstat[2],4,15,"Fit Any Temperature Range");
    cwintext(rtstat[2],5,15,"Use Any Number of Breakpoints");
    cwintext(rtstat[2],6,15,"Summary Statistics for Quality of Curvefit");
    cwintext(rtstat[2],7,15,"Integrated Graphics");
    cwintext(rtstat[2],8,15,"Generalized Curvefitting Can Be Used for Other Applications");
    settextstyle(0,0,1);
    tcfile = fopen("JFILE.TXT","rt");
    numdat = 60;
    yact=(realtype *) calloc(numdat,sizeof(realtype));
    yest=(realtype *) calloc(numdat,sizeof(realtype));
    xact=(realtype *) calloc(numdat,sizeof(realtype));
    i = 0;
    while (i < 58)
    {
	fscanf(tcfile,"%lf %lf %lf",&tcactual[i],&tcfitted[i],&tcxs[i]);
	*(yest+i)=tcfitted[i];
	*(yact+i)=tcactual[i];
	*(xact+i)=tcxs[i];
	i++;
    }
    fclose(tcfile);
    cwintext(rtstat[2],14,15,"PRESS ANY KEY TO CONTINUE");
    numdat = i-1;
    rtautoaxes(rtstat[1],xact,yact,numdat,1);
    rtlineplotdata(rtstat[1],xact,yact,numdat,15,0);
    rtlineplotdata(rtstat[1],xact,yest,numdat,13,0);
    rttitlewindow(rtstat[1],"J Thermocouple - Actual vs fitted values");
    rttitlexaxis(rtstat[1],"Microvolts");
    rttitleyaxis(rtstat[1],"Temp. Deg. C");

    if (mousefound)
	rtshowmouse();
    do 
    {
	cursec = getseconds();
    } while ((checkevent() == 0)  && (cursec < startsec+15))
	;
    if (checkevent() == 1)
	getkey();
    free(yact);
    free(yest);
    free(xact);
}



void buildpid1(void)
{
    int i;

    realtype  cursec,startsec;

    rtclearscreen();
    rtresetwindowdefaults(20);
    rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

    rtsetpercentwindow(rtstat[1],0.0,0.11,0.99,0.49);
    rtsetpercentwindow(rtstat[2],0.67,0.5,0.99,0.99);
    rtsetpercentwindow(rtstat[3],0.0,0.5,0.66,0.99);
    rtsetwin2plotratio(rtstat[3],0.0,0.0,0.0,0.0);

    settextstyle(1,0,1);
    cboldtitle(rtstat[0],1,15,"PID Control");
    settextstyle(0,0,1);

    lf[0] = 0;

    rtsetupscrollgraph(rtstat[1],1.0,0.01,0.0,1000.0,0.90,1,1,200.0, 800.0,
      550.0,2,0,"Reactor Vessel","Cent.",tags,lc,lf,0);
    rttitlexaxis(rtstat[1],"Minutes");

    strcpy(tags[0], "CV Temp.");
    strcpy(tags[1], "Setpoint");
    strcpy(tags[2], "Heater");
    rtsetupvbargraph(rtstat[2],0.0,1000.0,0.0,200.0,800.0,550.0,
      0, "Reactor Vessel","Cent.",tags,alarmstrings,3,lc,lf);
    drawdiagram(rtstat[3]);
    for (i = 0; i <= 3; i++)
	rtborderwindow(rtstat[i],15);
    if (mousefound)
	rtshowmouse();
    index = 0;
    for (i = 0; i <= 510; i++)
    {
	rr = (realtype)i;
	xdata[i] = (realtype)(i+1);
	ydata[i] =  20 + 530 * (1-exp(-rr/10)) +
	  300 * sin(rr/10) * (exp(-rr/20));
    }
    startsec = getseconds();
    do 
    {
	yvalues[0] = ydata[(int) index % 500];
	yvalues[1] = 550.0;
	yvalues[2] = 1000.0-yvalues[0];
	for (i = 1; i <= 2; i++)
	{
	    rtupdatedisplay(rtstat[i],yvalues);
	    rtdelay(100);
	}
	index++;
	cursec = getseconds();
    } while ((checkevent() == 0)  && (cursec < startsec+15))
	;
    if (checkevent() == 1)
	getkey();
}


void buildannunp1(void)
{
    int i;

    realtype cursec,startsec;

    rtclearscreen();
    rtresetwindowdefaults(20);

    rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

    rtsetpercentwindow(rtstat[1],0.0, 0.11, 0.66,0.25);
    rtsetpercentwindow(rtstat[2],0.0,0.26,0.66, 0.65);
    rtsetpercentwindow(rtstat[3],0.67,0.11,1.0,  0.65);

    rtsetpercentwindow(rtstat[4],0.0,0.66,1.0,1.0);

    farray[2] = 0;
    if (getmaxcolor() == 1)
	rtinitwindowcolors(rtstat[1],0,0,0,0,0,15,15);
    rtsetupannun(rtstat[1],lalarm,halarm, stpnt, 1, "ANNUNCIATOR", units,tags,
      halarms, lalarms,nalarms,1,6,lc,farray);
    farray[2] = 1;
    if (getmaxcolor() > 1)
	rtinitwindowcolors(rtstat[1],0,0,0,0,0,15,15);

    rtsetupannun(rtstat[2],lalarm,halarm, stpnt, 1, "ANNUNCIATOR", units,tags,
      halarms, lalarms,nalarms,2,3,lc,farray);

    if (getmaxcolor() > 1)
	rtinitwindowcolors(rtstat[1],0,0,0,0,0,15,15);

    rtsetupannun(rtstat[3],lalarm,halarm, stpnt, 1, "ANNUNCIATOR", units,tags,
      halarms, lalarms,nalarms,3,2,lc,farray);

    for (i = 0; i <= 4; i++)
	rtborderwindow(rtstat[i],15);
    settextstyle(1,0,1);
    cboldtitle(rtstat[0],1,15,"Annunciators");
    settextstyle(1,0,1);
    cwintext(rtstat[4],1,15,"Up to 16 Channels per Window");
    cwintext(rtstat[4],2,15,"Specify N Rows by M Columns");
    cwintext(rtstat[4],3,15,"Background Colors Change State with Alarms");
    cwintext(rtstat[4],4,15,"Display Tag Name, Current Value, Units");
    cwintext(rtstat[4],5,15,"Alarm Message for Alarm Conditions");
    cwintext(rtstat[4],6,15,"All Colors are User Programmable");
    settextstyle(0,0,1);
    cwintext(rtstat[4],11,15,"PRESS ANY KEY TO CONTINUE");
    if (mousefound)
	rtshowmouse();
    startsec = getseconds();
    do 
    {
	yvalues[0] = ydata[(int) index % 500];
	yvalues[1] = 100 + ydata[(int) (index+100) % 500];
	yvalues[2] = ydata[(int) (index+10) % 500];
	yvalues[3] = ydata[(int) (index+30) % 500];
	yvalues[4] = ydata[(int) (index+50) % 500];
	yvalues[5] = ydata[((int) index+100) % 500];
	rtdelay(100);
	for (i = 1; i <= 3; i++)
	{
	    rtupdatedisplay(rtstat[i],yvalues);
	}
	index++;
	cursec = getseconds();
    } while ((checkevent() == 0)  && (cursec < startsec+15))
	;
    if (checkevent() == 1)
	getkey();
}

void buildmetersp1(void)
{
    int i;

    realtype cursec,startsec;

    rtclearscreen();
    rtresetwindowdefaults(20);
    rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

    rtsetpercentwindow(rtstat[1],0.0, 0.11, 0.33,0.65);
    rtsetpercentwindow(rtstat[2],0.34,0.11,0.66, 0.65);
    rtsetpercentwindow(rtstat[3],0.67,0.11,1.0,  0.65);

    rtsetpercentwindow(rtstat[4],0.0,0.66,1.0,1.0);
    rtsetupmeter(rtstat[1],0.0, 1000.0, 0.5, 0.5, 0.5,300, 240,
      300.0,800.0,400.0,0,"NEEDLE METER","Fahr.",
      tags,alarmstrings,2,10,2,
      lc,lf);
    rtsetuppiemeter(rtstat[2],0.0, 1000.0,0.0, 0.5, 0.5, 0.5,300,240,
      30.0,900.0,500.0,0,"PIE METER","Fahr.",
      tags,alarmstrings,1,10,2,
      lc,lf);
    rtsetuparcmeter(rtstat[3],0.0, 1000.0,0.0, 0.5, 0.5, 0.5,300, 240,
      300.0,900.0,500.0,0,"ARC METER","Fahr.",
      tags,alarmstrings,1,10,2,
      lc,lf);


    for (i = 0; i <= 4; i++)
	rtborderwindow(rtstat[i],15);
    settextstyle(1,0,1);
    cboldtitle(rtstat[0],1,15,"Needle Pie and Arc Meters");
    settextstyle(1,0,1);
    cwintext(rtstat[4],1,15,"Flexible Meter Window Sizing");
    cwintext(rtstat[4],2,15,"Programmable Meter Arc");
    cwintext(rtstat[4],3,15,"High and Low Alarm Markers");
    cwintext(rtstat[4],4,15,"PID Setpoint Marker");
    cwintext(rtstat[4],5,15,"Alarm Message for Alarm Conditions");
    cwintext(rtstat[4],6,15,"All Colors are User Programmable");
    settextstyle(0,0,1);
    cwintext(rtstat[4],11,15,"PRESS ANY KEY TO CONTINUE");
    if (mousefound)
	rtshowmouse();
    startsec = getseconds();
    do 
    {
	yvalues[0] = ydata[(int) index % 500];
	yvalues[1] = 100 + ydata[(int) (index+100) % 500];
	yvalues[2] = ydata[(int) (index+10) % 500];
	yvalues[3] = ydata[(int) (index+10) % 500];
	for (i = 1; i <= 3; i++)
	{
	    if ((index % 8) == 0)
		rtupdatedisplay(rtstat[i],yvalues);
	}
	index++;
	cursec = getseconds();
    } while ((checkevent() == 0)  && (cursec < startsec+15))
	;
    if (checkevent() == 1)
	getkey();
}


void buildbargraphsp1(void)
{
    int i;

    realtype cursec,startsec;

    rtresetwindowdefaults(20);
    rtclearscreen();
    rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);
    rtsetpercentwindow(rtstat[1],0.0,0.11,0.20,0.65);
    rtsetpercentwindow(rtstat[2],0.21,0.11,0.55,0.65);
    rtsetpercentwindow(rtstat[3],0.56,0.11,1.0,0.35);
    rtsetpercentwindow(rtstat[4],0.56,0.36,1.0,0.65);
    rtsetpercentwindow(rtstat[5],0.0,0.66,1.0,1.0);

    rtsetupvbargraph(rtstat[1],0.0,1000.0,0.0,350.0,700.0,550.0,0,
      "BARGRAPH #1","RPM",tags,alarmstrings,1,lc,lf);

    rtsetupvbargraph(rtstat[2],0.0,1000.0,0.0,350.0,700.0,550.0,0,
      "BARGRAPH #2","RPM",tags,alarmstrings,4,lc,lf);

    rtsetuphbargraph(rtstat[3],0.0,1000.0,0.0,350.0,700.0,550.0,0,
      "BARGRAPH #3","RPM",tags,alarmstrings,1,lc,lf);

    rtsetuphbargraph(rtstat[4],0.0,1000.0,0.0,350.0,700.0,550.0,0,
      "BARGRAPH #4","RPM",tags,alarmstrings,4,lc,lf);

    for (i = 0; i <= 5; i++)
	rtborderwindow(rtstat[i],15);
    settextstyle(1,0,1);
    cboldtitle(rtstat[0],1,15,"Horizontal and Vertical Bargraphs");
    settextstyle(1,0,1);
    cwintext(rtstat[5],1,15,"Flexible Bargraph Window Sizing");
    cwintext(rtstat[5],2,15,"Up to 16 Bars per Bargraph Window");
    cwintext(rtstat[5],3,15,"High and Low Alarm Markers");
    cwintext(rtstat[5],4,15,"PID Setpoint Marker");
    cwintext(rtstat[5],5,15,"Alarm Messages for Alarm Conditions");
    cwintext(rtstat[5],6,15,"All Colors are User Programmable");
    settextstyle(0,0,1);
    cwintext(rtstat[5],11,15,"PRESS ANY KEY TO CONTINUE");
    if (mousefound)
	rtshowmouse();
    startsec = getseconds();
    do 
    {
	yvalues[0] = ydata[index % 500];
	yvalues[1] = 100 + ydata[(index+100) % 500];
	yvalues[2] = ydata[(index+10) % 500];
	yvalues[3] = ydata[(index+10) % 500];
	for (i = 1; i <= 4; i++)
	{
	    if ((index % 8) == 0)
		rtupdatedisplay(rtstat[i],yvalues);
	}
	index++;
	cursec = getseconds();
    } while ((checkevent() == 0)  && (cursec < startsec+15))
	;
    if (checkevent() == 1)
	getkey();
}

void openbanner(void)
{
    char s1[80],s2[80],s3[80];

    rtsetviewbackground(rtstat[0],0);
    rtborderwindow(rtstat[0],15);
	 strcpy(s1, "IOtech REAL-TIME GRAPHICS");
    strcpy(s2, "AND MEASUREMENT CONTROL TOOLS");
    strcpy(s3, "FOR TURBO C, TURBO PASCAL AND MICROSOFT C");
    xtext(s1,s2,s3);
}

void setupmainconstants(void)
{
    int i;

    for (i = 0; i <= 510; i++)
    {
	rr = (realtype)i;
	xdata[i] = (realtype)(i+1);
	ydata[i] =  500.0 + 300.0 * sin(rr/10.0);
	ydata2[i] =  500.0 + 300.0 * sin(rr/200.0);
    }
    lf[0]= 0;
    lf[1] = 0;
    lf[2] = 0;
    for (i = 0 ; i <= 15; i++)
    {
	lc[i] = 2 + (i % 4);
	lc2[i] = 15;
	switch (i) 
	{
	case 0:
	    strcpy(tags[i],"Temp01");
	    break;
	case 1:
	    strcpy(tags[i], "Temp02");
	    break;
	case 2:
	    strcpy(tags[i], "Temp03");
	    break;
	case 3:
	    strcpy(tags[i], "Flow01");
	    break;
	case 4:
	    strcpy(tags[i], "Flow02");
	    break;
	case 5:
	    strcpy(tags[i], "Flow03");
	    break;
	default:
	    strcpy(tags[i], "TempXX");
	}
	lalarm[i] = 350.0;
	halarm[i] = 650.0;
	stpnt[i] = 350.0;
	if (i < 3)
	    strcpy(units[i],"Fahr");
	else
	    if (i < 6)
	    strcpy(units[i],"GPM");
	else
	    strcpy(units[i], "Fahr");
	strcpy(halarms[i], "HIGH");
	strcpy(lalarms[i], "LOW");
	strcpy(nalarms[i], "OK");
	strcpy(message[i], "RTSUBS");
    }
    for (i = 0; i <=9; i++)
	if (i < 6)
	    farray[i] = 1;
	else
	    farray[i] = 0;
    strcpy(alarmstrings[0], "LOW");
    strcpy(alarmstrings[1], "OK");
    strcpy(alarmstrings[2], "HIGH");

}

void setupmainwindows(void)
{
    rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);
    rtsetpercentwindow(rtstat[1],0.0,0.11,0.33,0.55);
    rtsetpercentwindow(rtstat[2],0.34,0.11,0.66,0.55);
    rtsetpercentwindow(rtstat[3],0.67,0.11,1.0,0.55);
    rtsetpercentwindow(rtstat[4],0.0,0.56,0.33,1.0);

    rtsetpercentwindow(rtstat[5],0.34,0.56,0.69,0.82);
    rtsetpercentwindow(rtstat[6],0.70,0.56,1.0,0.82);

    rtsetpercentwindow(rtstat[7],0.34,0.83,0.69,1.0);
    rtsetpercentwindow(rtstat[8],0.70,0.83,1.0,1.0);

}

void setupmaingraphs(int dobanner)
{
    int i;

    setlinestyle(0,0,1);
    rtinitwindowcolors(rtstat[1],1,1,2,4,15,15,15);
    rtsetupscrollgraph(rtstat[1],4.0,0.10,0.0,1000.0,0.97,1,0,-300.0, -700.0,
      -550.0,1,0,"SCROLL GRAPHS - PRESS 1","Fahr.",
      tags,lc,lf,0);

    rtinitwindowcolors(rtstat[2],1,0,2,4,15,15,15);
    rtsetupvbargraph(rtstat[2],0.0,1000.0,0.0,350.0,700.0,550.0,0,
      "BARGRAPHS - PRESS 2","RPM",tags,alarmstrings,3,lc,lf);

    lf[0] = 0;
    lf[1] = 0;
    rtinitwindowcolors(rtstat[3],1,1,2,4,15,15,15);
    rtsetupmeter(rtstat[3],0.0, 1000.0,0.50, 0.5, 0.45,320, 220,
      100.0,800.0,550.0,0,"METERS - PRESS 3","Fahr.",
      tags,alarmstrings,2,20,2,lc,lf);

    if (getmaxcolor()==1)
	rtinitwindowcolors(rtstat[4],0,0,0,0,0,15,15);
    rtsetupannun(rtstat[4],lalarm,halarm, stpnt, 1, "ANNUNCIATORS - PRESS 4", units,tags,
      halarms, lalarms,nalarms,2,2,lc2,farray);
    for (i = 0; i <=8; i++)
	rtborderwindow(rtstat[i],15);

    settextstyle(1,0,1);
    cwintext(rtstat[5],1,15,"Press 5");
    cwintext(rtstat[5],2,15,"Thermocouple");
    cwintext(rtstat[5],3,15,"Curvefitting");
    cwintext(rtstat[5],4,15,"and");
    cwintext(rtstat[5],5,15,"Linearization");

    cwintext(rtstat[6],1,15,"Press 6");
    cwintext(rtstat[6],2,15,"Application");
    cwintext(rtstat[6],3,15,"Examples");

    cwintext(rtstat[7],1,15,"Press 7");
    cwintext(rtstat[7],2,15,"PID Control");

    cwintext(rtstat[8],1,15,"Press 8");
    cwintext(rtstat[8],2,15,"Quit");
    if (dobanner)
	openbanner();
    settextstyle(1,0,1);
    cboldtitle(rtstat[0],1,15,"MAKE SELECTION - PRESS F1 - F8");
    settextstyle(0,0,1);
    cwintext(rtstat[0],3,15,"OR USE MOUSE TO SELECT");
}

void rtexplodewindow(int wi, int se, int ee)
{
    int incx1,incx2,incy1,incy2,kk,mx,my;
    unsigned x1,y1,x2,y2,i;

    for (i = se; i <=ee; i++)
    {
	if (i != wi)
	    rtclearwindow(rtstat[i]);
    }
    rtsetgraphviewport(0,0,getmaxx(), getmaxy());
    x1 = (*rtstat[wi]).dr.left;
    x2 = (*rtstat[wi]).dr.right;
    y1 = (*rtstat[wi]).dr.top;
    y2 = (*rtstat[wi]).dr.bottom;
    mx = getmaxx();
    my = getmaxy();
    kk = 0;
    incx1 = x1 / 16;
    incx2 = (mx - x2) / 16;
    incy1 = y1 / 16;
    incy2 = (my - y2) / 16;

    do 
    {
	x1-=incx1;
	x2+=incx2;
	y1-=incy1;
	y2+=incy2;
	rtsetcolor(getmaxcolor());
	rtrectangleni(x1,y1,x2,y2);
	rtsetcolor(0);
	rtrectangleni(x1,y1,x2,y2);
	kk++;
    } while (kk <= 16)
	;
}

int updatemaingraphs(void)
{
    int x,y,status,i,result;
    char  ch;

    if (rtmouseon())
	rtshowmouse();
    do 
    {
	yvalues[0] = ydata[index % 500];
	yvalues[1] = 100 + ydata[(index+100) % 500];
	yvalues[2] = 200 + ydata[(index+100) % 500];
	y2values[0] = ydata2[index % 500];
	y2values[1] = 100 + ydata2[(index+100) % 500];
	y2values[2] = 150+ydata2[(index+10) % 500];
	y2values[3] = 200+ ydata2[(index+10) % 500];
	for (i = 1; i <=4; i++)
	{
	    if (i == 1)
		rtupdatedisplay(rtstat[i],yvalues);
	    if (((index  % 4)==0) && (i != 1))
	    {
		rtupdatedisplay(rtstat[i],y2values);
	    }
	}
	index++;
    } while (checkevent() == 0)
	;
    if (checkevent() == 1)  
    {
	ch = getkey();
	result = ch - '0';
    }
    if (checkevent() == 2)
    {
	rtgetmouse(&status,&x,&y);
	result = rtfindmousewin(rtstat,1,8,x,y);
    }
    rtexplodewindow(result,0,8);
    return(result);
}

void textbox(int left, int top, int w, int h)
{
    unsigned xx,yy,i,j;
    char  blank[80];
    char hl,vl,ul,ur,ll,lr;

    xx = 1;
    yy = 1;
    strcpy(blank, "");
    hl = 196;
    vl = 179;
    ul = 218;
    ur = 191;
    ll = 192;
    lr= 217;
    {
	for (i = 1; i <=w-2; i++) 
	{
	    gotoxy(left+i,top);
	    printf("%c",hl);
	}
	for (i = 1; i <=w-2; i++) 
	{
	    gotoxy(left+i,top+h-1);
	    printf("%c",hl);
	}
	for (j = 1; j <= h-2; j++) 
	{
	    gotoxy(left,top+j);
	    printf("%c",vl);
	}
	for (j = 1; j <= h-2; j++) 
	{
	    gotoxy(left+w-1,top+j);
	    printf("%c",vl);
	}
	gotoxy(left,top);
	printf("%c",ul);
	gotoxy(left+w-1,top);
	printf("%c",ur);
	gotoxy(left,top+h-1);
	printf("%c",ll);
	gotoxy(left+w-1,top+h-1);
	printf("%c",lr);
	for (j = 1; j <= h-2; j++)
	{
	    gotoxy(left+1,top+j);
	    printf("%76c",blank);
	}
    }
    gotoxy(xx,yy);
}

void main()
{

    xdata =(realtype *) calloc(600,sizeof(realtype));
    ydata =(realtype *) calloc(600,sizeof(realtype));
    ydata2 = (realtype *) calloc(600,sizeof(realtype));
    ydata3 = (realtype *) calloc(600,sizeof(realtype));
    ydata4 = (realtype *) calloc(600,sizeof(realtype));

    tcxs = (realtype *) calloc(61,sizeof(realtype));
    tcfitted = (realtype *) calloc(61,sizeof(realtype));
    tcactual = (realtype *) calloc(61,sizeof(realtype));

    lalarm =  (realtype *) calloc(16,sizeof(realtype));
    halarm =  (realtype *) calloc(16,sizeof(realtype));
    stpnt =   (realtype *) calloc(16,sizeof(realtype));
    y3values = (realtype *) calloc(16,sizeof(realtype));
    y2values = (realtype *) calloc(16,sizeof(realtype));
    yvalues =  (realtype *) calloc(16,sizeof(realtype));

    tags = (tagtype *) calloc(16,sizeof(tagtype));
    units= (tagtype *) calloc(16,sizeof(tagtype));
    halarms= (tagtype *) calloc(16,sizeof(tagtype));
    lalarms= (tagtype *) calloc(16,sizeof(tagtype));
    nalarms= (tagtype *) calloc(16,sizeof(tagtype));

    index = 0;
    if (rttestforherc()==1) rthercmouse();
    rtinitmouse(&mousefound,&buttons);
    rtinitgraphics(-2,defaultfontdir,21,rtstat,1);
    if (mousefound)
    {
      rtsetmousemaxx(0,getmaxx());
      rtsetmousemaxy(0,getmaxy());
    }

    setupmainwindows();
    setupmainconstants();
    setupmaingraphs(1);
    if (mousefound)
	rtshowmouse();
    do
    {
	mainaction = updatemaingraphs();
	switch (mainaction)
	{
	case 1:
	    buildscrollp1();
	    break;
	case 2:
	    buildbargraphsp1();
	    break;
	case 3:
	    buildmetersp1();
	    break;
	case 4:
	    buildannunp1();
	    break;
	case 5:
	    buildtcp1();
	    break;
	case 6:
	    buildap1();
	    break;
	case 7:
	    buildpid1();
	    break;
	case 8:
	    ;
	}
	if (mainaction != 8)
	{
      rtresetwindowdefaults(20);

      rtclearscreen();
	    setupmainwindows();
	    setupmainconstants();
	    setupmaingraphs(0);
	}
    } while  (mainaction != 8)
	;
    rtclosegraphics(rtstat,1);
}
